-- LizardTT.lua
-- Script for Lizrad LizardTT
--
-- Author Rival
-- 05.01.2016
-- Version 1.1 @26.10.2016
	--> converted to FS17

LizardTT = {};

function LizardTT.prerequisitesPresent(specializations)
    return true;
end;

function LizardTT:load(savegame)
    self.blinkerLight0 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LizardTT.blinkerLight#index0"));
    self.blinkerLight1 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LizardTT.blinkerLight#index1"));
    self.blinkerLight2 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LizardTT.blinkerLight#index2"));
    -- self.warnBlinkLight = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LizardTT.warnBlinkLight#index"));
    setVisibility(self.blinkerLight0, false);
    setVisibility(self.blinkerLight1, false);
    setVisibility(self.blinkerLight2, false);
    self.hasAttachedTrailers = 0;

	self.shuttle = {};
	self.shuttle.node = Utils.indexToObject( self.components, getXMLString(self.xmlFile, "vehicle.LizardTT.shuttle#node") );
	
	if self.shuttle.node ~= nil then
		--Forward position
		self.shuttle.rotFwd = {0, 0, 0};
		local rx, ry, rz = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.LizardTT.shuttle#rotFwd"));
		if rx ~= nil and ry ~= nil and rz ~= nil then
			self.shuttle.rotFwd = {math.rad(rx), math.rad(ry), math.rad(rz)};
		end;
		--Backward position
		self.shuttle.rotBwd = {0, 0, 0};
		rx, ry, rz = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.LizardTT.shuttle#rotBwd"));
		if rx ~= nil and ry ~= nil and rz ~= nil then
			self.shuttle.rotBwd = {math.rad(rx), math.rad(ry), math.rad(rz)};
		end;
		--Neutral/handbrake position
		self.shuttle.rotNeut = {0, 0, 0};
		rx, ry, rz = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.LizardTT.shuttle#rotNeut"));
		if rx ~= nil and ry ~= nil and rz ~= nil then
			self.shuttle.rotNeut = {math.rad(rx), math.rad(ry), math.rad(rz)};
		end;
	end;

	self.forward = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LizardTT.forward#index"));
	self.reverse = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LizardTT.reverse#index"));
	self.neutral = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LizardTT.neutral#index"));
	
end;

function LizardTT:delete()
end;

function LizardTT:mouseEvent(posX, posY, isDown, isUp, button)
end;

function LizardTT:keyEvent(unicode, sym, modifier, isDown)
end;

function LizardTT:update(dt)
    if self:getIsActive() and self.isClient then
        if table.getn(self.attachedImplements) > 0 or self.hasAttachedTrailers > 0 then
            self.hasAttachedTrailers = 0;
            for i=1, table.getn(self.attachedImplements) do  
                if self.attachedImplements[i].object.hasTurnLights and self.attachedImplements[i].object.hasTurnLights then 
                    self.hasAttachedTrailers = self.hasAttachedTrailers + 1;
                end;
                if table.getn(self.attachedImplements[i].object.attachedImplements) > 0 then
                    for r=1, table.getn(self.attachedImplements[i].object.attachedImplements) do
                        if self.attachedImplements[i].object.attachedImplements[r].object.hasTurnLights and self.attachedImplements[i].object.attachedImplements[r].object.hasTurnLights then
                            self.hasAttachedTrailers = self.hasAttachedTrailers + 1;
                        end;
                    end;
                end;
            end;
        end;
        if self.hasAttachedTrailers == 0 then
            setVisibility(self.blinkerLight0, self.turnLightState ~= Lights.TURNLIGHT_OFF);
            setVisibility(self.blinkerLight1, false);
            setVisibility(self.blinkerLight2, false);
        elseif self.hasAttachedTrailers == 1 then
            setVisibility(self.blinkerLight0, self.turnLightState ~= Lights.TURNLIGHT_OFF);
            setVisibility(self.blinkerLight1, self.turnLightState ~= Lights.TURNLIGHT_OFF);
            setVisibility(self.blinkerLight2, false);
        elseif self.hasAttachedTrailers == 2 then
            setVisibility(self.blinkerLight0, self.turnLightState ~= Lights.TURNLIGHT_OFF);
            setVisibility(self.blinkerLight1, self.turnLightState ~= Lights.TURNLIGHT_OFF);
            setVisibility(self.blinkerLight2, self.turnLightState ~= Lights.TURNLIGHT_OFF);
        end;
        -- if self.turnLightState == Lights.TURNLIGHT_HAZARD then
            -- setVisibility(self.warnBlinkLight, true);
        -- else
            -- setVisibility(self.warnBlinkLight, false);
        -- end;
    end;

	local isOn = false;
			if self.mrGbMS ~= nil then
				isOn = self:mrGbMGetIsOnOff();
			end;
			if isOn then
				LizardTT.updateShuttleMrGbMS(self);
				-- LizardTT.updatePedalsMrGbMS(self, dt);
			elseif self.driveControl and self.driveControl.shuttle.isActive then
				LizardTT.updateShuttleDC(self);
				-- LizardTT.updatePedalsDC(self, dt);
			else
				LizardTT.updateShuttle(self);
				-- LizardTT.updatePedals(self, dt);
			end;
	
		if self:getLastSpeed() * self.speedDisplayScale > 1 and self.movingDirection > 0 then
			if self.forward ~= nil then
				setVisibility(self.forward, true);
				setVisibility(self.neutral, false);
			end;
		elseif self:getLastSpeed() * self.speedDisplayScale > 1 and self.movingDirection < 0 then
			if self.reverse ~= nil then
				setVisibility(self.reverse, true);
				setVisibility(self.neutral, false);
			end;
		else
			if self.forward ~= nil then
				setVisibility(self.forward, false);
				setVisibility(self.neutral, true);
			end;
			if self.reverse ~= nil then
				setVisibility(self.reverse, false);
				setVisibility(self.neutral, true);
			end;
		end;
	
end;

function LizardTT.updateShuttleDC(self)
	if not self.shuttle.node then
		return;
	end;
	--print(self.lastSpeed);
	if self.driveControl.shuttle.direction > 0 and self.lastSpeed > 0.0001 then
		setRotation( self.shuttle.node, self.shuttle.rotFwd[1], self.shuttle.rotFwd[2], self.shuttle.rotFwd[3] );
	elseif self.driveControl.shuttle.direction < 0 and self.lastSpeed > 0.0001 then
		setRotation( self.shuttle.node, self.shuttle.rotBwd[1], self.shuttle.rotBwd[2], self.shuttle.rotBwd[3] );
	else
		setRotation( self.shuttle.node, self.shuttle.rotNeut[1], self.shuttle.rotNeut[2], self.shuttle.rotNeut[3] );
	end;
end;
-- DEFAULT --
function LizardTT.updateShuttle(self)
	if not self.shuttle.node then
		return;
	end;
	--print(self.movingDirection );
	if self.movingDirection > 0.0001 then
		setRotation( self.shuttle.node, self.shuttle.rotFwd[1], self.shuttle.rotFwd[2], self.shuttle.rotFwd[3] );
	elseif self.movingDirection < -0.0001 then
		setRotation( self.shuttle.node, self.shuttle.rotBwd[1], self.shuttle.rotBwd[2], self.shuttle.rotBwd[3] );
	else
		setRotation( self.shuttle.node, self.shuttle.rotNeut[1], self.shuttle.rotNeut[2], self.shuttle.rotNeut[3] );
	end;
end;

function LizardTT:updateTick(dt)
end;
function LizardTT:draw()    
end;